package idv.cjcat.bunnyhill.nodes {
	import idv.cjcat.bunnyhill.IDisposable;
	import idv.cjcat.bunnyhill.render.visitor.IRenderVisitor;
	import idv.cjcat.signals.ISignal;
	
	public interface INode extends IDisposable {
		
		function get onPriorityChange():ISignal;
		function get priority():Number;
		function set priority(value:Number):void;
		
		function get timestamp():int;
		
		function visit(visitor:IRenderVisitor):void;
		function update(visitor:IRenderVisitor):void;
		function render(visitor:IRenderVisitor):void;
	}
}