package idv.cjcat.bunnyhill.nodes {
	import idv.cjcat.bunnyhill.geom.Vec2D;
	import idv.cjcat.bunnyhill.render.visitor.IRenderVisitor;
	import idv.cjcat.signals.ISignal;
	import idv.cjcat.signals.Signal;
	
	public class Node implements INode {
		
		//signals
		//------------------------------------------------------------------------------------------------
		
		private var _onPriorityChange:ISignal = new Signal(INode);
		public function get onPriorityChange():ISignal { return _onPriorityChange; }
		
		//------------------------------------------------------------------------------------------------
		//end of signals
		
		
		/** @private */
		internal var _priority:Number = 0;
		public function get priority():Number { return _priority; }
		public function set priority(value:Number):void {
			if (_priority != value) {
				_priority = value;
				_onPriorityChange.dispatch(this);
			}
		}
		
		private var _timestamp:int = 0;
		public function get timestamp():int { return _timestamp; }
		
		public function Node() {
			
		}
		
		public final function visit(visitor:IRenderVisitor):void {
			if (_timestamp != visitor.timestamp) {
				_timestamp = visitor.timestamp;
				update(visitor);
			}
			render(visitor);
		}
		
		public function update(visitor:IRenderVisitor):void {
			
		}
		
		public function render(visitor:IRenderVisitor):void {
			
		}
		
		public function dispose():void {
			
		}
	}
}