package idv.cjcat.bunnyhill.render.buffer {
	import flash.display3D.Context3D;
	import flash.display3D.Context3DTextureFormat;
	import idv.cjcat.bunnyhill.IDisposable;
	import idv.cjcat.bunnyhill.utils.TextureDimensionData;
	import idv.cjcat.bunnyhill.utils.TextureUtils;
	
	internal class RenderBufferPoolUnit implements IDisposable {
		
		private var _context3D:Context3D;
		private var _width:int;
		private var _height:int;
		
		private var _vec:Vector.<IRenderBuffer> = new Vector.<IRenderBuffer>();
		private var _position:int = 0;
		
		public function RenderBufferPoolUnit(context3D:Context3D, width:int, height:int) {
			_context3D = context3D;
			_width = width;
			_height = height;
		}
		
		public function get():IRenderBuffer {
			var result:IRenderBuffer;
			if (_position > 0) {
				
				result = _vec[--_position];
				_vec[_position] = null;
				return result;
			} else {
				
				result = new RenderBuffer(
					_context3D.createTexture(
						_width, 
						_height, 
						Context3DTextureFormat.BGRA, 
						true
					), 
					_width, 
					_height
				);
				
				return result;
			}
		}
		
		public function recycle(renderBuffer:IRenderBuffer):void {
			_vec[_position] = renderBuffer;
			++_position;
		}
		
		public function dispose():void {
			for (var i:int = _vec.length - 1; i >= _position; --i) {
				_vec[i].dispose();
			}
		}
	}
}