package idv.cjcat.bunnyhill.render.visitor {
	import idv.cjcat.bunnyhill.render.buffer.IRenderBufferPool;
	import idv.cjcat.signals.ISignal;
	
	public interface IRenderVisitor {
		
		//signals
		//------------------------------------------------------------------------------------------------
		
		function get onStageResize():ISignal;
		
		//------------------------------------------------------------------------------------------------
		//end of signals
		
		function get stageWidth():Number;
		function get stageHeight():Number;
		function get antiAlias():int;
		
		function reset(stageWidth:Number, stageHeight:Number, antiAlias:int):void;
		
		function get frame():int;
		function nextFrame():int;
		function resetFrame():int;
		
		function get timeStep():Number;
		function set timeStep(value:Number):void;
		
		function get timestamp():int;
		function set timestamp(value:int):void;
		
		function get graphics():IGraphics;
		function get alphaStack():INumberStack;
		function get matrixStack():IMatrixStack;
		
		function get renderBufferPool():IRenderBufferPool;
		
		function dispose():void;
	}
}