package idv.cjcat.bunnyhill.shaders {
	import com.adobe.pixelBender3D.AGALProgramPair;
	import com.adobe.pixelBender3D.PBASMCompiler;
	import com.adobe.pixelBender3D.PBASMProgram;
	import com.adobe.pixelBender3D.utils.ProgramConstantsHelper;
	import flash.display3D.Context3D;
	import flash.display3D.Program3D;
	
	public class ShaderProgram implements IShaderProgram {
		
		private var _context3D:Context3D;
		
		private var _program3D:Program3D;
		public function get program3D():Program3D { return _program3D; }
		
		private var _parameters:ProgramConstantsHelper;
		public function get parameters():ProgramConstantsHelper { return _parameters; }
		
		private var _vertexProgram:IVertexProgram;
		public function get vertexProgram():IVertexProgram { return _vertexProgram; }
		
		private var _materialProgram:IMaterialProgram;
		public function get materialProgram():IMaterialProgram { return _materialProgram; }
		
		private var _fragmentProgram:IFragmentProgram;
		public function get fragmentProgram():IFragmentProgram { return _fragmentProgram; }
		
		public function ShaderProgram(vertexProgram:IVertexProgram, materialProgram:IMaterialProgram, fragmentProgram:IFragmentProgram) {
			_vertexProgram = vertexProgram;
			_materialProgram = materialProgram;
			_fragmentProgram = fragmentProgram;
		}
		
		private var _lateUpdate:Boolean = false;
		public function updateParameters():void {
			if (_parameters) _parameters.update();
			else _lateUpdate = true;
		}
		
		public function setup(context3D:Context3D):void {
			if (_context3D != context3D) {
				
				if (_context3D) _program3D.dispose();
				
				var programs:AGALProgramPair = 
					PBASMCompiler.compile(
						_vertexProgram.program, 
						_materialProgram.program, 
						_fragmentProgram.program
					);
				
				_parameters = new ProgramConstantsHelper(
					context3D, 
					programs.vertexProgram.registers, 
					programs.fragmentProgram.registers
				);
				
				_program3D = context3D.createProgram();
				_program3D.upload(programs.vertexProgram.byteCode, programs.fragmentProgram.byteCode);
				
				_context3D = context3D;
			}
			
			_context3D.setProgram(_program3D);
		}
	}
}