package idv.cjcat.bunnyhill.shaders.basic {
	import flash.display3D.Context3D;
	import flash.display3D.Context3DProgramType;
	import flash.geom.Matrix3D;
	import idv.cjcat.bunnyhill.shaders.ShaderProgram;
	
	public class BasicShaderProgram extends ShaderProgram {
		
		private var _matrix:Matrix3D = new Matrix3D();
		public function get matrix():Matrix3D { return _matrix.clone(); }
		public function set matrix(value:Matrix3D):void {
			value.copyToMatrix3D(_matrix);
			parameters.setMatrixParameterByName(Context3DProgramType.VERTEX, "matrix", _matrix, true);
		}
		
		private var _alpha:Number = 1;
		public function get alpha():Number { return _alpha; }
		public function set alpha(value:Number):void {
			_alpha = value;
			parameters.setNumberParameterByName(Context3DProgramType.FRAGMENT, "alpha", Vector.<Number>([_alpha]));
		}
		
		public function BasicShaderProgram() {
			super(
				new BasicVertexProgram(), 
				new BasicMaterialProgram(), 
				new BasicFragmentProgram()
			);
		}
	}
}