package idv.cjcat.bunnyhill.stardust.handlers {
	import idv.cjcat.bunnyhill.nodes.DrawBitmapData;
	import idv.cjcat.bunnyhill.nodes.IGroup;
	import idv.cjcat.bunnyhill.nodes.INode;
	import idv.cjcat.bunnyhill.nodes.Transform;
	import idv.cjcat.bunnyhill.stardust.initializers.BHParticleNode;
	import idv.cjcat.stardust.common.handlers.ParticleHandler;
	import idv.cjcat.stardust.common.particles.Particle;
	import idv.cjcat.stardust.twoD.particles.Particle2D;
	
	public class BHGroupHandler extends ParticleHandler {
		
		public var container:IGroup;
		
		public function BHGroupHandler(container:IGroup = null) {
			this.container = container;
		}
		
		override public function particleAdded(particle:Particle):void {
			container.add(INode(particle.target));
			particle.dictionary[BHGroupHandler] = container;
		}
		
		override public function particleRemoved(particle:Particle):void {
			container.remove(INode(particle.target));
			delete particle.dictionary[BHGroupHandler];
		}
		
		private var n:BHParticleNode;
		private var p2D:Particle2D;
		override public function readParticle(particle:Particle):void {
			n = BHParticleNode(particle.target);
			p2D = Particle2D(particle);
			n.position.set(p2D.x, p2D.y);
			n.rotation = p2D.rotation;
			n.scale.set(p2D.scale, p2D.scale);
			n.alpha = p2D.alpha;
		}
	}
}